//A Simple Greeter Bot

// compile:

//This program implements a very simple bot.  The bot logs into the universe, enters a world, and says "hello" to every user that enters the world.

#include "Aw.h"
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/socket.h>
#include <fcntl.h>
//#include <errno.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <arpa/inet.h>

#include <stdio.h>
#include <time.h>
#include <signal.h>
#include <unistd.h>
#define true 1
#define false 0


//extern int h_errno;

static int entered=0,entercode=0;
void handle_avatar_add (void);
void handle_chat (void);
void handle_enter (int rc);

main (int argc, char *argv[])
{

  int rc;
  int i,n;

  /* check command line */
  if (argc < 4) 
  {
    printf ("Usage: %s citnumber password world\n", argv[0]);
    exit (1);
  }
  
  /* initialize Active Worlds API */
  if (rc = aw_init (AW_BUILD)) 
  {
    printf ("Unable to initialize API (reason %d)\n", rc);
    exit (1);
  }
printf("AW Init called\n");
  /* install handler for avatar_add event */
  aw_event_set (AW_EVENT_AVATAR_ADD, handle_avatar_add);
  aw_event_set (AW_EVENT_CHAT, handle_chat);
  aw_callback_set(AW_CALLBACK_ENTER, handle_enter);
  /* create bot instance */
  if (rc = aw_create ("auth.activeworlds.com", 6670, 0 )) 
  {
    printf ("Unable to create bot instance (reason %d)\n", rc);
    exit (1);
  }
printf("AW create called\n");
  /* log bot into the universe */
//  aw_int_set (AW_LOGIN_OWNER, atoi (argv[1]));
  aw_event_set (AW_EVENT_AVATAR_ADD, handle_avatar_add);
  aw_event_set (AW_EVENT_CHAT, handle_chat);
  aw_callback_set(AW_CALLBACK_ENTER, handle_enter);
  aw_int_set (AW_LOGIN_OWNER, atoi(argv[1]));
  aw_string_set (AW_LOGIN_PRIVILEGE_PASSWORD, argv[2]);
  aw_string_set (AW_LOGIN_APPLICATION, "SDK Sample Application #1");
  aw_string_set (AW_LOGIN_NAME, "GreeterBot");
printf("aw_login call\n");
  if (rc = aw_login ()) 
  {
    printf ("Unable to login (reason %d)\n", rc);
    exit (1);
  }
printf("aw_login called for %s\n","GreeterBot");

  /* log bot into the world  */
printf ("Entering to world %s\n",argv[3]);
  entered=false;
  aw_bool_set(AW_ENTER_GLOBAL,true);
  if (rc = aw_enter (argv[3])) 
  {
	 printf ("Unable to enter world (reason %d)\n", rc);
	 exit (1);
  }
  while (1)
  {
	  if (entered) break;
	  aw_wait(10);
  }
  
  if (entercode)
  {
	 printf ("Unable to enter world (reason %d)\n", rc);
	 aw_destroy();
	 aw_wait(0);
	 aw_term();
	 exit (1);
  }
printf ("Entered to world %s \n",argv[3]);
  /* announce our position in the world */
  aw_int_set (AW_MY_X, 1000); /* 1W */
  aw_int_set (AW_MY_Z, 1000); /* 1N */
  aw_int_set (AW_MY_YAW, 2250); /* face towards GZ */
  if (rc = aw_state_change ()) 
  {
	  printf ("Unable to change state (reason %d)\n", rc);
	  aw_destroy();
	  aw_wait(0);
	  aw_term();
	  exit (1);
  }
printf ("State changed \n");
  /* main event loop */
printf("type q <cr> for quit\n");
  while (1)
  {
	  fd_set rfds;
	  struct timeval tv;
	  int retval;

	  /* Watch stdin (fd 0) to see when it has input. */
	  FD_ZERO(&rfds);
	  FD_SET(0, &rfds);
	  /* Wait up to 100 mseconds. */
	  tv.tv_sec = 0;
	  tv.tv_usec = 100000;

	  retval = select(1, &rfds, NULL, NULL, &tv);
	  /* Don't rely on the value of tv now! */

	  if (retval)
	  {
		  if (getchar() == 'q')
		  {
			  aw_destroy();
			  aw_wait(0);
			  aw_term();
			  return 0;
		  }
	  };
	  aw_wait(10);
  }

  /* close everything down */
  aw_destroy ();
  aw_wait(0);
  aw_term ();
  return 0;

}

void handle_avatar_add (void)
{

  char message[100];
//  printf ("avatar_add by %s: %s\n",(char *)aw_user_data(), aw_string (AW_AVATAR_NAME));
  if (aw_string (AW_AVATAR_NAME)[0]=='[') return;  // don't greet bots
  sprintf (message, "Hello %s", aw_string (AW_AVATAR_NAME));
  aw_say (message);
  /* log the event to the console */

}
void handle_enter(int rc)
{
	entered=1;
	printf("Enter code=%d\n",rc);
	entercode=rc;
}

static char* chat_type[] = {"Chat ", "Broadcast ", "Whisper "};

void handle_chat(void)
{
	printf("%s %s: %s\n",chat_type[aw_int (AW_CHAT_TYPE)], aw_string(AW_AVATAR_NAME),aw_string(AW_CHAT_MESSAGE));
}


